
local addonName, CFE = ...

------------------
-- / DEFAULTS / --
------------------
CFE.defaults = {
	Collapsed = 0,
	HideButton = 0,
}

------------------
-- / SETUP DB / --
------------------
local function CFE_SetupDB(defaults, db)
	if type(defaults) ~= "table" then return db end
	if type(db) ~= "table" then db = {} end
	
	for k, v in pairs(defaults) do
		if type(v) == "table" then
			db[k] = CFE_SetupDB(db[k], v)
		elseif type(v) ~= type(db[k]) then
			db[k] = v
		end
	end
	
	return db
end

--------------------
-- / INITIALIZE / --
--------------------
function CFE_InitializeDatabase()
	CFEDB = CFE_SetupDB(CFE.defaults, CFEDB)
	CFE.db = CFEDB
end