
local addonName, CFE = ...

-----------------
-- / SCRIPTS / --
-----------------
local function CharacterFrameExpandButton_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT", 0, -45)
	
	if (CharacterFrame.Expanded) then
		GameTooltip:SetText(STATS_COLLAPSE_TOOLTIP, 1, 1, 1)
	else
		GameTooltip:SetText(STATS_EXPAND_TOOLTIP, 1, 1, 1)
	end
	
	GameTooltip:Show()
end

local function CharacterFrameExpandButton_OnLeave()
	GameTooltip:Hide()
end

local function CharacterFrameExpandButton_OnClick(self)
	if (CharacterFrame.Expanded) then
		PlaySound("igCharacterInfoClose");
		db.Collapsed = 1
		CharacterFrame_Collapse();
	else
		PlaySound("igCharacterInfoOpen");
		db.Collapsed = 0
		CharacterFrame_Expand();
	end
	
	if (GameTooltip:GetOwner() == self) then
		self:GetScript("OnEnter")(self);
	end
end

local function CharacterFrameExpandButton_OnUpdate(self)
	if (CharacterFrame.Expanded) then
		self:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Up");
		self:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Down");
	else
		self:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up");
		self:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down");
	end
	
	if (db.HideButton ~= 0) then
		self:Hide()
	end
end

----------------------
-- / SETUP BUTTON / --
----------------------
local function CFE_SetupButton()
	CharacterFrameExpandButton = CreateFrame("Button", "CharacterFrameExpandButton", PaperDollFrame)
	CharacterFrameExpandButton:ClearAllPoints()
	CharacterFrameExpandButton:SetPoint("BOTTOMRIGHT", CharacterFrameInset, -2, -1)
	CharacterFrameExpandButton:SetSize(32, 32)
	CharacterFrameExpandButton:RegisterForClicks("LeftButtonUp")
	CharacterFrameExpandButton:SetHighlightTexture("Interface\\BUTTONS\\UI-Common-MouseHilight")
	
	CharacterFrameExpandButton:SetScript("OnEnter", CharacterFrameExpandButton_OnEnter)
	CharacterFrameExpandButton:SetScript("OnLeave", CharacterFrameExpandButton_OnLeave)
	CharacterFrameExpandButton:SetScript("OnClick", CharacterFrameExpandButton_OnClick)
	CharacterFrameExpandButton:SetScript("OnUpdate", CharacterFrameExpandButton_OnUpdate)
end

--------------------
-- / INITIALIZE / --
--------------------
function CFE_InitializeButton()
	db = CFE.db
	CFE_SetupButton()
end