--[[ Cards for Masque ]]

local MSQ = LibStub("Masque", true)
if not MSQ then return end

MSQ:AddSkin("Cards: Hearts",{
	Author = "Kallieen",
	Version = "6.2.0",
	Shape = "Square",
	Masque_Version = 60200,
	Backdrop = {
		Width = 25,
		Height = 25,
		Texture = [[Interface\Addons\Masque_Cards\Textures\HeartsBackdrop]],
		
	},
	Icon = {
		Width = 25,
		Height = 25,
		TexCoords = {0.07,0.93,0.07,0.93}, -- Keeps the icon from showing its "silvery" edges.
	},
	Border = {
		Width = 62,
		Height = 62,
		Texture = [[Interface\Buttons\UI-ActionButton-Border]],
		BlendMode = "ADD",
	},
	Flash = {
		Width = 36,
		Height = 36,
		Texture = [[Interface\Buttons\UI-QuickslotRed]],
	},
	Cooldown = {
		Width = 36,
		Height = 36,
	},
	AutoCast = {
		Width = 36,
		Height = 36,
	},
	AutoCastable = {
		Width = 58,
		Height = 58,
		Texture = [[Interface\Buttons\UI-AutoCastableOverlay]],
	},
	Normal = {
		Width = 36,
		Height = 36,
		Texture = [[Interface\AddOns\Masque_Cards\Textures\HeartsNormal]],
		Static = true,
	},
	Pushed = {
		Hide = true,
	},
	Disabled = {
		Hide = true,
	},
	Checked = {
		Width = 36,
		Height = 36,
		Texture = [[Interface\Buttons\CheckButtonHilight]],
		BlendMode = "ADD",
	},
	Gloss = {
		Width = 32,
		Height = 32,
		Texture = [[Interface\AddOns\Masque_Cards\Textures\Gloss]],
	},
	Highlight = {
		Width = 36,
		Height = 36,
		Texture = [[Interface\AddOns\Masque_Cards\Textures\Highlight]],
		BlendMode = "ADD",
	},
	HotKey = {
		Width = 36,
		Height = 5,
		OffsetX = 4,
		OffsetY = -1,
		Fontsize = 14,
	},
	Count = {
		Width = 36,
		Height = 5,
		OffsetX = 0,
		OffsetY = 5,
		Fontsize = 12,
	},
	Name = {
		Width = 36,
		Height = 10,
		OffsetY = 0,
	},
	-- Skin data end.

},true)

--Clubs

MSQ:AddSkin("Cards: Clubs",{
	-- Skin Data Begin
	Template = "Cards: Hearts",
	Backdrop = {
		Width = 30,
		Height = 30,
		Texture = [[Interface\AddOns\Masque_Cards\Textures\ClubsBackdrop]],
	},
	Normal = {
		Texture = [[Interface\AddOns\Masque_Cards\Textures\ClubsNormal]],
		Static = true,
	},
	-- Skin Data End
},true)

--Spades

MSQ:AddSkin("Cards: Spades",{
	-- Skin Data Begin
	Template = "Cards: Hearts",
	Backdrop = {
		Width = 30,
		Height = 30,
		Texture = [[Interface\AddOns\Masque_Cards\Textures\SpadesBackdrop]],
	},
	Normal = {
		Texture = [[Interface\AddOns\Masque_Cards\Textures\SpadesNormal]],
		Static = true,
	},
	-- Skin Data End
},true)
		
--Diamonds

MSQ:AddSkin("Cards: Diamonds",{
	-- Skin Data Begin
	Template = "Cards: Hearts",
	Backdrop = {
		Width = 36,
		Height = 36,
		Texture = [[Interface\AddOns\Masque_Cards\Textures\DiamondsBackdrop]],
	},
	Normal = {
		Texture = [[Interface\AddOns\Masque_Cards\Textures\DiamondsNormal]],
		Static = true,
	},
	-- Skin Data End
},true)